PROBLEM LINK:Author: Dmytro Berezin PREREQUISITES:Dynamic programming PROBLEM:Chef has an image $S$ consisting of just $10$ pixels in a row. Each pixel is either black or white. There are $N$ filters, where each filter is a string of length $10$ consisting of How many different subsets of the filters will turn the image into an allblack image? QUICK EXPLANATION:We can replace images and filters with binary numbers of at most $S$ bits, where "white" and Let $c_i$ be the number of filters $i$ present in the input. Define $f(i,j)$ be the number of ways to turn the image $j$ into an allblack image (i.e. image $0$) using only the first $i+1$ distinct kinds of filters. We can compute $f(i,j)$ using dynamic programming. The following is a recurrence for $f(i,j)$: $$f(i,j) = \begin{cases} [j = 0] & \text{if $i = 1$} \\\ f(i1,j) & \text{if $i \ge 0$ and $c_i = 0$} \\\ \left[f(i1,j) + f(i1,j\oplus i)\right]2^{c_i1} & \text{if $i \ge 0$ and $c_i > 0$} \end{cases}$$ The answer is simply $f(2^{S}1, S)$. (where $S$ is not the absolute value, rather it is the length of the original input string. In this problem this value is always $10$.) Since there are around $4^{S} \le 1.05\times 10^6$ possible arguments to $f$, we can tabulate $f(i,j)$. If the entries of this table is filled in order of increasing $i$, then we'll be able to compute all entries in just $O(4^{S})$ time. EXPLANATION:The problem can be stated in terms of binary strings. An "image" and a "filter" is really just a binary string of length $10$. So let's say we replace "white" and "
The problem is now: Given an integer $S$ and a set of $N$ filters (represented by integers), how many subsets of filters are there such that applying the bitwiseXOR of each filter to $S$ results in image $0$? Note that filters are considered distinct even if they are represented by the same integer. Subsets with bitwise XOR zero$N$ can be very large, especially in the last subtask, so this seems intractable. However, notice that while $N$ can reach up to $10^5$, the number of distinct filters is at most $2^{10}$. This suggests grouping the filters according to the integer representing them. This reordering/grouping doesn't affect the answer, because order doesn't matter in subsets (and also because bitwise XOR is commutative and associative). So now, instead of our $N$ filters, we can replace it with a list $c_0, c_1, c_2 \ldots c_{2^{10}1}$, where $c_i$ is the number of filters that are represented by the integer $i$. Now, what happens if we apply a set of filters represented by the same integer, say, $i$? After applying the first one, the image becomes $S\oplus i$. Then after applying the second one, it becomes the value $S\oplus i\oplus i$. But this is just equal to $S$! In other words, applying two equivalent filters is the same as applying none at all. Okay, let's proceed. After applying third one, the number becomes $S\oplus i$ again, which is the same as applying only once! We can continue with this for more and more filters to get the following fact: Applying an odd number of equivalent filters is the same as applying just one equivalent filter. Applying an even number of equivalent filters is the same as applying none. This makes things much easier. Suppose we look at a particular integer, say $i$. Then there are only two possible outcomes when applying any number of filters with the integer $i$ to $S$: $S$ and $S\oplus i$. Also, applying every even subset of our set of filters results in $S$, and applying every odd subset results in $S\oplus i$. Thus, we just need to know how many subsets are odd and even. Suppose there are $c_i$ filters. How many subsets are there? For each element, there are two choices, whether to include it or not, so there are $\underbrace{2\cdot 2\cdots 2}_{c_i}$ or $2^{c_i}$ subsets. How many of those are even? Similarly as above, we can choose, for each element, whether to include it or not. Thus, there are again two choices for each element. However, the last element is special! This is because we want to ensure that the size of the set is even. So in selecting the last element, we first check whether the size of the subset already constructed is even or odd. If it is odd, then we have no choice but to include the last element to the set to make it even. If it is even, then we have no choice but to exclude the last element, otherwise it will be odd. Therefore, after making the choices for the first $c_i  1$ elements, there is a unique choice for the last element. This implies that the number of evensized subsets is equal to $2^{c_i1}$! A very similar argument shows that there are also $2^{c_i1}$ oddsized subsets. Note that the argument above only holds for $c_i$ is not $0$. But the case $c_i = 0$ is trivial: there is only one such set, namely the empty set, and it is even. Armed with this, we can now devise a dynamic programming solution for the problem. Let's define $f(i,j)$ as the number of ways to turn the image $j$ into image $0$ using only the first $i+1$ distinct kinds of filters. The answer is simply $f(2^{10}1, S)$. To compute $f(i,j)$, consider the filters represented by $i$. There are $c_i$ such filters. There are $2^{c_i1}$ evensized subsets, and when every such set of filters is applied, the resulting image is $j$. There are $2^{c_i1}$ oddsized subsets, and when every such set of filters is applied, the resulting image is $j\oplus i$. Therefore, we have the following general recurrence: $$f(i,j) = \left[f(i1,j) + f(i1,j\oplus i)\right]2^{c_i1}$$ (don't forget to reduce modulo $10^9 + 7$!) Note that this only works when $i \ge 0$ and $c_i > 0$. If $c_i = 0$, then there are no filters $i$ so we can simply say $f(i,j) = f(i1,j)$. Finally, if $i < 0$, then there are no filters to apply altogether, and the only way to turn $j$ into zero is if $j$ is already zero! Thus, we have: $f(1,0) = 1$ and $f(1,j) = 0$ for $j \not= 0$. Summarizing these formulas, we now have the following: $$f(i,j) = \begin{cases} [j = 0] & \text{if $i = 1$} \\\ f(i1,j) & \text{if $i \ge 0$ and $c_i = 0$} \\\ \left[f(i1,j) + f(i1,j\oplus i)\right]2^{c_i1} & \text{if $i \ge 0$ and $c_i > 0$} \end{cases}$$ (The expression "$[j = 0]$" uses the Iverson bracket notation.) Since there are around $4^{10} \le 1.05\times 10^6$ possible distinct arguments to $f$, we can tabulate $f(i,j)$, and populate this table in increasing order of $i$. Filling a table of up to $10^6$ elements easily passes the time limit, even in Python! (This is an example of dynamic programming.) Appendix: bitwise XORIt's helpful to refresh oneself about the bitwise XOR operation. The bitwise XOR of two numbers is obtained by writing two numbers in binary, padding with leading zeroes if necessary so they have the same number of digits, and "XOR"ing each column. The resulting binary number is the bitwise XOR. (Remember that the XOR of two bits is $1$ if they are different, and $0$ if they are the same.) For example, the bitwise XOR of $143=10001111_2$ and $202=11001010_2$ can be obtained as: $$\begin{matrix} & 10001111 \\ \oplus & 11001010 \\ \hline & 01000101 \end{matrix}$$ Thus, $143\oplus 202=01000101_2=69$. Based on this definition, the bitwise XOR has the following properties (straightforward to prove):
$$\begin{align*}
a\oplus b &\equiv b\oplus a && \text{commutativity law} \\\
(a\oplus b)\oplus c &\equiv a\oplus (b\oplus c) && \text{associativity law} \\\
a\oplus 0 &\equiv a && \text{identity law} \\\
a\oplus a &\equiv 0 && \text{inverse law}
\end{align*}$$
(we invite you to derive these properties yourself) Time Complexity:$O(4^{S})$ AUTHOR'S AND TESTER'S SOLUTIONS:
This question is marked "community wiki".
asked 12 Dec '15, 19:53

concise editorial of four easy problems: https://shadekcse.wordpress.com/2015/12/14/codechefdec15challenge/ answered 14 Dec '15, 20:59

For all those who got TLE in last task, % operator for them proved really costly :D answered 14 Dec '15, 15:22
1
with % operator : https://www.codechef.com/viewsolution/8948976 without % : https://www.codechef.com/viewsolution/8910699 I calculted the number of subsets, with XOR equal to value of the image represented as a binary number.
(14 Dec '15, 15:26)
Yep! I removed all the MOD's and just calculated manually and it got me AC. Its a really efficient optimization here.
(14 Dec '15, 15:39)

I wanted to know if the solution mentioned in the editorial is a DP with bitmask or just a normal DP approach..? answered 16 Dec '15, 19:22
Normal DP approach, not a bitwiseDP For more info read at https://discuss.codechef.com/questions/77747/howtherecursionforcheffiltworks
(16 Dec '15, 21:06)
Thnk you..
(16 Dec '15, 21:42)

This is my code https://www.codechef.com/viewsolution/8975829 and I have got 50points for this. The last test case gives TLE and I have no idea what I'm missing. Can anybody help me by finding the mistake. answered 18 Dec '15, 17:54
Your approach is O(N∗1024∗T). You need to be lucky to pass with that solution. Try the approach mentioned in the editorial O(T10241024).
(18 Dec '15, 18:00)
@xariniov Few of them passed all test cases with the same complexity.So I was wondering whats wrong with my code.
(18 Dec '15, 18:01)
Mine also did pass all the test cases during the contest. I'm not sure, if they add stronger test cases for practice problem or it might be a case that your solution has a bigger hidden constant factor.
(18 Dec '15, 18:05)

Unfortunately, some $O(N*1024*T)$ solutions passed as well. answered 14 Dec '15, 16:10

using Gaussian elimination : https://www.codechef.com/viewsolution/8922862 answered 15 Dec '15, 07:40

can some body tell me what i am missing. i could'nt figure out where i was failing..! https://www.codechef.com/viewsolution/8947831 answered 14 Dec '15, 15:21

I did the question using gaussian elimination , and it got AC in just 0.08 sec :) Here is the link answered 14 Dec '15, 16:29

I did it using O(N x 1024 x T) and it passed.Lucky for me. Can anyone explain why it happened?.I mean for N=100000,T=5 it becomes O(100000x1024x5).I too was surprised when it did not give tle. I used bottomup and optimised mod using if(a>=mod)a=mod; answered 14 Dec '15, 18:53
